<?php
/*
 * Copyright 2008, Constant Contact
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


require "Constants.php";

      $uploadedFile = $_FILES['uploadedfile']['tmp_name'];
      // Get the lists fields
      $lists = $_POST['lists'];

      // First validate that a file was uploaded and is readable
      if (!file_exists($uploadedFile) || !is_readable($uploadedFile)){
         echo "No file was uploaded!";
      }

      else if ($lists == null){
         echo "You must pick at least one list.";
      }

      else{
         $fileContents = file_get_contents($uploadedFile);


	  // assemble post url
	  $postVars = "activityType=SV_ADD&lists=";
	  foreach ($lists as $tmp){
	     $postVars = $postVars . urlencode($tmp) . "&";
	  }
	  $postVars = $postVars . "&data=" . urlencode($fileContents);

	  $request =  URI . "/ws/customers/" . $_POST[PARAM_NAME_USER_NAME] . "/activities";
	  
  	  // Initialize the session
	  $session = curl_init($request); 
		
	  // Set up Digest authentication - username and password.
	  $userNamePassword = $_POST[PARAM_NAME_API_KEY] . '%' . $_POST[PARAM_NAME_USER_NAME] . ':' . $_POST[PARAM_NAME_PASSWORD];

	  curl_setopt($session, CURLOPT_HTTPAUTH, CURLAUTH_DIGEST);
	  curl_setopt($session, CURLOPT_USERPWD, $userNamePassword);
	  curl_setopt($session, CURLOPT_FOLLOWLOCATION  ,1); 
	  curl_setopt($session, CURLOPT_POST, 1);
	  curl_setopt($session, CURLOPT_POSTFIELDS , $postVars);
	  curl_setopt($session, CURLOPT_HEADER, 0);   // Do not return headers

	  // The following option tells Curl to not send the result of the execution to the browser
	  // This must be set to 1 or true in order to process the resulting xml programatically. 
	  curl_setopt($session, CURLOPT_RETURNTRANSFER, 1);  // return contents of the call, do not push to the browser

  	  $response = curl_exec($session);

	  //echo $response;
	  curl_close($session);

	  // Get the XML from the response, bypassing the header
	  if (!($xml = strstr($response, '<?xml'))) {
	      $xml = null;
	      echo $response; 
	      // XML is Null!!! Must display an error. 
	  }
	  else{
	  	// Response looks like the following
		/*
	 	<entry xmlns="http://www.w3.org/2005/Atom">
		  <link href="/ws/customers/joesmith/activities/a07e1kzjaukfg9lal17" rel="edit" />
		  <id>http://api.constantcontact.com/ws/customers/kmandeville/activities/a07e1kzjaukfg9lal17</id>
		  <title type="text"></title>
		  <updated>2008-05-15T17:02:20.155Z</updated>
		  <link href="/ws/customers/joesmith/activities/a07e1kzjaukfg9lal17" rel="edit" />
		</entry>	
		*/
		$data = simplexml_load_string($xml);
		$location = $data->id;
		// Redirect to the showActivity page
		$relativeUrl="showActivity.php?activityLink=" . urlencode($location) . "&".PARAM_NAME_API_KEY."=" . $_REQUEST[PARAM_NAME_API_KEY] .
		   "&". PARAM_NAME_USER_NAME."=" . $_REQUEST[PARAM_NAME_USER_NAME] . "&".PARAM_NAME_PASSWORD."=". $_REQUEST[PARAM_NAME_PASSWORD];
		    // redirect to view page. 
		    header("Location: " . LOCAL_BASE_URL. $relativeUrl);
	  }

      }
?>